Package: MerfishData
Title: Collection of public MERFISH datasets
Version: 1.12.0
Authors@R: 
    c(person("Ludwig", "Geistlinger", 
             role = c("aut", "cre"),
             email = "ludwig_geistlinger@hms.harvard.edu", 
             comment = c(ORCID = "0000-0002-2495-5464")),
      person("Tyrone", "Lee", role = "ctb"),
      person("Helena", "Crowell", role = "ctb",
             comment = c(ORCID = "0000-0002-4801-1767")), 
      person("Daniela", "Corbetta", role = "ctb"), 
      person("Jeffrey", "Moffitt", role = "aut"),
      person("Robert", "Gentleman", role = "aut"))
Description: MerfishData is an ExperimentHub package that serves publicly available
    datasets obtained with Multiplexed Error-Robust Fluorescence in situ Hybridization
    (MERFISH). MERFISH is a massively multiplexed single-molecule imaging technology
    capable of simultaneously measuring the copy number and spatial distribution
    of hundreds to tens of thousands of RNA species in individual cells. The scope
    of the package is to provide MERFISH data for benchmarking and analysis.
License: Artistic-2.0
VignetteBuilder: knitr
URL: https://github.com/ccb-hms/MerfishData
BugReports: https://github.com/ccb-hms/MerfishData/issues
Depends: R (>= 4.2.0), EBImage, SpatialExperiment
Imports: grDevices, AnnotationHub, BumpyMatrix, ExperimentHub,
        S4Vectors, SingleCellExperiment, SummarizedExperiment,
        HDF5Array
Suggests: grid, ggplot2, ggpubr, knitr, rmarkdown, scater, scattermore,
        terra, testthat, BiocStyle, DropletUtils
biocViews: ExperimentHub, ExpressionData, HighThroughputImagingData,
        Mus_musculus_Data, SingleCellData, SpatialData
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/MerfishData
git_branch: RELEASE_3_22
git_last_commit: 42395d2
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-04 16:37:53 UTC; biocbuild
Author: Ludwig Geistlinger [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-2495-5464>),
  Tyrone Lee [ctb],
  Helena Crowell [ctb] (ORCID: <https://orcid.org/0000-0002-4801-1767>),
  Daniela Corbetta [ctb],
  Jeffrey Moffitt [aut],
  Robert Gentleman [aut]
Maintainer: Ludwig Geistlinger <ludwig_geistlinger@hms.harvard.edu>

# MerfishData
Collection of public MERFISH datasets

## Installation

### Installation from Bioconductor

The package is available from [Bioconductor](https://bioconductor.org/).
Please follow the installation instructions on the
[package landing page](https://bioconductor.org/packages/MerfishData)
to install the package.

### Installation from GitHub

Make sure to have the latest release version of 
[R](https://cran.r-project.org/) installed.

Then proceed from within R via:

```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install(version = "devel")
BiocManager::valid()
```

to install the 
[BiocManager](https://cran.r-project.org/web/packages/BiocManager/index.html) package
and to use the
[development version of Bioconductor](https://contributions.bioconductor.org/use-devel.html).

This is necessary as the `MerfishData` package uses resources from ExperimentHub
that are currently only available in the development version of Bioconductor.

The package itself can then be installed via:

```
BiocManager::install("ccb-hms/MerfishData")
```

NOTE: you will need the `remotes` package to install from github. 

To build the package vignettes upon installation use:

```
BiocManager::install("ccb-hms/MerfishData",
                     build_vignettes = TRUE,
                     dependencies = TRUE)
```

Once you have the package installed, you can inspect the vignettes from within
R via:

```
browseVignettes("MerfishData")
```

#' MERFISH mouse colon IBD dataset from Cadinu et al., 2024
#' @description Obtain the MERFISH mouse colon IBD dataset from Cadinu et al.,
#' 2024
#' @details Gut inflammation involves contributions from immune and non-immune cells,
#' whose interactions are shaped by the spatial organization of the healthy gut and its
#' remodeling during inflammation.
#' The crosstalk between fibroblasts and immune cells is an important axis in this process,
#' but our understanding has been challenged by incomplete cell-type definition and biogeography.
#'
#' To address this challenge, Cadinu et al., 2024 used multiplexed error-robust
#' fluorescence in situ hybridization
#' (MERFISH) to profile the expression of 943 genes in 1.35 million cells imaged
#' across the onset and recovery from a mouse colitis model.
#' They identified diverse cell populations, charted their
#' spatial organization, and revealed their polarization or recruitment in
#' inflammation.
#'
#' The barcoding scheme contained 990 possible barcodes; 943 of them were used to
#' code the RNAs of the genes assayed via combinatorial smFISH across different
#' stages of colitis in a mouse model; 47 of these barcodes
#' were left unassigned ("blank"), providing a direct measure of the false-positive
#' rate in MERFISH. Measurements for these 47 blank barcodes is stored in an
#' `altExp` named \code{"blank"}.
#'
#' The dataset includes cell type labels with three levels of granularity.
#' Data were collected at multiple time points: prior to the onset of colitis
#' (\code{sample_type="Healthy"}) and at intervals of 3 days, 9 days, 
#' and 21 days post-onset.
#'
#' @return An object of class \code{\linkS4class{SpatialExperiment}}.
#' @references Cadinu et al. (2024) Charting the cellular biogeography in
#' colitis reveals fibroblast trajectories and coordinated spatial remodeling.
#' Cell, 187(8).
#' @source \url{https://doi.org/10.5061/dryad.rjdfn2zh3}
#' @examples spe <- MouseColonIbdCadinu2024()
#' @export

MouseColonIbdCadinu2024 <- function()
{
    eh <- ExperimentHub::ExperimentHub()
    recs <- AnnotationHub::query(eh, c("MERFISH", "Cadinu2024"))

    # setup progress bar
    counter <- 0
    pb <- NULL
    if (interactive()) {
        nr.items <- length(recs) - 3
        pb <- txtProgressBar(counter, nr.items, style = 3)
    }

    # (1) retrieve colData and identify reducedDims
    cdat <- .getResource(recs, "_coldata")
    if (interactive()) {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }
    pcs <- grep("^PC\\d{1,3}$", colnames(cdat))
    umap <- grep("^UMAP", colnames(cdat))
    umap1 <- grep("Neigh_", colnames(cdat))
    umap2 <- grep("Tier2", colnames(cdat))
    umap3 <- grep("Tier3", colnames(cdat))

    # (2) create spe object for the blanks features
    blank.spe <- SpatialExperiment(
        assays = list(
            counts = .getHDF5(recs, "ibd_blanks_counts", "counts"),
            logcounts = .getHDF5(recs, "ibd_blanks_logcounts", "logcounts")
        )
    )
    if (interactive()) {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }
    rownames(blank.spe) <- .getResource(recs, "ibd_blanks_rownames")
    if (interactive()) {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }

    # (3) create spe with all the components
    spe <- SpatialExperiment(
        assays = list(
            counts = .getHDF5(recs, "ibd_counts", "counts"),
            logcounts = .getHDF5(recs, "ibd_logcounts", "logcounts")
        ),
        colData = cdat[, -c(pcs, umap, umap1, umap2, umap3)],
        metadata = .getResource(recs, "metadata"),
        reducedDims = list(
            PCA = cdat[, pcs],
            UMAP = cdat[, umap],
            UMAP_Tier1 = cdat[, umap1],
            UMAP_Tier2 = cdat[, umap2],
            UMAP_Tier3 = cdat[, umap3]
        ),
        altExps = list(Blank = blank.spe),
        spatialCoordsNames = c("x", "y")
    )
    if (interactive()) {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }

    rownames(spe) <- .getResource(recs, "ibd_rownames")
    if (interactive()) {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }

    return(spe)
}

.getHDF5 <- function(recs, suffix, name)
{
    file_path <- .getResource(recs, suffix)
    obj <- HDF5Array::HDF5Array(file_path, name)
    return(obj)
}

context("Colon IBD")

checkSPE <- function(spe) {
    # check overall object
    expect_is(spe, "SpatialExperiment")
    expect_true(nrow(spe) > 940)
    expect_true(ncol(spe) > 1300000)
    
    # check colData
    cdat.cols <- c("cell_id", "sample_id", "sample_type", "mouse_id", 
                   "technical_repeat_number", "slice_id", "fov", "n_genes",
                   "tier1", "tier2", "tier3", "leiden_neigh")
    expect_true(all(cdat.cols %in% colnames(colData(spe))))
    
    # check spatialCoords
    expect_equal(ncol(spatialCoords(spe)), 2)
    expect_true(all(colnames(spatialCoords(spe)) == c("x", "y")))
    expect_true(is.numeric(spatialCoords(spe)))
    cdat <- colData(spe)
    expect_true(ncol(cdat) == length(cdat.cols))
    expect_true(nrow(cdat) == ncol(spe))
    
    # check altExps
    expect_true("Blank" %in% altExpNames(spe))
    blank_spe <- altExp(spe, "Blank")
    expect_is(blank_spe, "SpatialExperiment")
    expect_equal(nrow(blank_spe), 47)
    
    # check reducedDims
    expect_true("PCA" %in% reducedDimNames(spe))
    expect_true("UMAP" %in% reducedDimNames(spe))
    expect_true("UMAP_Tier1" %in% reducedDimNames(spe))
    expect_true("UMAP_Tier2" %in% reducedDimNames(spe))
    expect_true("UMAP_Tier3" %in% reducedDimNames(spe))
    expect_true(ncol(reducedDim(spe, "PCA")) == 50)
    
    # check metadata
    metadata <- metadata(spe)
    expect_true(length(metadata) > 0)
    expect_true(is.list(metadata))
}

test_that("standard usage", {
  spe <- MouseColonIbdCadinu2024()
  checkSPE(spe)
})

#' Collection of public MERFISH datasets
#' 
#' @description MerfishData is an ExperimentHub package that serves publicly available
#' datasets obtained with Multiplexed Error-Robust Fluorescence in situ Hybridization
#' (MERFISH). MERFISH is a massively multiplexed single-molecule imaging technology
#' capable of simultaneously measuring the copy number and spatial distribution
#' of hundreds to tens of thousands of RNA species in individual cells. The scope
#' of the package is to provide MERFISH data for benchmarking and analysis.
#'
#' @name MerfishData-package
#' @aliases MerfishData-package MerfishData
#' @docType package
#' @author Ludwig Geistlinger <ludwig_geistlinger@@hms.harvard.edu>
#' @import EBImage
#' @import SpatialExperiment
#' @importFrom grDevices as.raster
#' @importFrom S4Vectors metadata metadata<-
#' @importFrom utils setTxtProgressBar txtProgressBar
#' @importFrom HDF5Array HDF5Array
NULL

#' MERFISH mouse hypothalamus dataset from Moffitt et al., 2018
#' @description Obtain the MERFISH mouse hypothalamic preoptic region dataset
#' from Moffitt et al., 2018
#' @details The hypothalamus controls essential social behaviors and homeostatic
#' functions. However, the cellular architecture of hypothalamic nuclei, including
#' the molecular identity, spatial organization, and function of distinct cell
#' types, is not well understood.
#'
#' Moffitt et al., 2018, developed an imaging-based cell type identification and
#' mapping method and combined it with single-cell RNA-sequencing to create a
#' molecularly annotated and spatially resolved cell atlas of the mouse hypothalamic
#' preoptic region.  
#'
#' The MERFISH measurements were obtained via combinatorial smFISH imaging for
#' 135 genes (main experiment named \code{"smFISH"}), followed by sequential rounds
#' of non-combinatorial seqFISH for 20 additional genes (stored as an `altExp`
#' named \code{"seqFISH"}). These genes were considered neuronal markers and important
#' for discriminating neuronal cell populations. For behavioral measurements,
#' cFos was added to the set of genes measured with sequential rounds of FISH.
#'   
#' The barcoding scheme contained 140 possible barcodes; 135 of them were used to
#' code the RNAs of the genes assayed via combinatorial smFISH; 5 of these barcodes
#' were left unassigned ("blank"), providing a direct measure of the false-positive
#' rate in MERFISH. Measurements for these 5 blank barcodes is stored in an 
#' `altExp` named \code{"blank"}.
#'
#' @param center.coords logical. Should spatial x- and y-coordinates be centered
#' for each z-layer (bregma slice)? This is useful for making coordinates
#' comparable between bregma slices for visualization and analysis. 
#' Defaults to \code{TRUE}. Use \code{FALSE} to obtain the coordinates as
#' provided in the data release.
#' @return An object of class \code{\linkS4class{SpatialExperiment}}.
#' @references Moffitt et al. (2018) Molecular, spatial, and functional
#' single-cell profiling of the hypothalamic preoptic region. 
#' Science, 362(6416), eaau5324.
#' @source \url{https://doi.org/10.5061/dryad.8t8s248}
#' @examples spe <- MouseHypothalamusMoffitt2018()
#' @export
MouseHypothalamusMoffitt2018 <- function(center.coords = TRUE)
{
    eh <- ExperimentHub::ExperimentHub()
    recs <- AnnotationHub::query(eh, c("MERFISH", "Mofitt2018"))
    
    seg.dat <- .getResource(recs, "_segmentation")

    # (1) expression matrix (assay)
    ind <- grep("Neuron_cluster_ID", colnames(seg.dat))
    genes <- colnames(seg.dat)[(ind + 1):ncol(seg.dat)]
    exprs <- t(as.matrix(seg.dat[,genes]))
    colnames(exprs) <- NULL 
     
    # (2) cell metadata (colData)
    cdat <- seg.dat[,seq_len(ind)]
    colnames(cdat)[c(2:3,5:7)] <- c("sample_id", "sex", "z", "x", "y")
    colnames(cdat) <- tolower(colnames(cdat))
    if(center.coords) cdat <- .centerCoords(cdat)
    rownames(cdat) <- NULL 

    spe <- SpatialExperiment::SpatialExperiment(assays = list(exprs = exprs),
                                                colData = cdat,
                                                spatialCoordsNames = c("x", "y", "z"))
    # (3) store blanks separately as an altExp
    spe <- .separateBlanks(spe)

    # (4) add molecules
    spe <- .addMolecules(spe, recs)
    return(spe)
}

.centerCoords <- function(cdat)
{
    cdat$z <- factor(cdat$z, levels = unique(cdat$z))
    sids <- unique(cdat$sample_id)
    for(i in sids)
    {
        ind <- cdat$sample_id == i
        ccdat <- cdat[ind,]
        spl <- split(ccdat, ccdat$z)
        
        for(j in seq_along(spl)) 
        {   
            spl[[j]]$x <- scale(spl[[j]]$x, scale = FALSE)
            spl[[j]]$y <- scale(spl[[j]]$y, scale = FALSE)
        }
    
        cdat[ind,] <- do.call(rbind, spl)
    }
    cdat$z <- as.numeric(as.character(cdat$z))
    return(cdat)
}

# blanks (= negative controls)
.separateBlanks <- function(spe)
{
    blanks <- paste("Blank", 1:5, sep = "_")
    blank.exprs <- assay(spe)[blanks,]
    blank.spe <- SpatialExperiment::SpatialExperiment(
                    assays = list(exprs = blank.exprs)) 
    ind <- setdiff(rownames(spe), blanks)
    spe <- spe[ind,]
    SingleCellExperiment::altExps(spe)$Blank <- blank.spe   
    return(spe)
}

.separateAnalogs <- function(spe, mol.dat)
{
    sf.genes <- setdiff(rownames(spe), mol.dat$gene)
    sf.exprs <- assay(spe)[sf.genes,]
    sf.spe <- SpatialExperiment::SpatialExperiment(
                    assays = list(exprs = sf.exprs)) 
    ind <- setdiff(rownames(spe), sf.genes)
    spe <- spe[ind,]
    SingleCellExperiment::altExps(spe)$seqFISH <- sf.spe   
    SingleCellExperiment::mainExpName(spe) <- "smFISH"
    return(spe)
}

.addMolecules <- function(spe, recs)
{
    # extract relevant columns
    mol.dat <- .getResource(recs, "_molecules")
    rel.cols <- c("Gene_name", "Cell_name", "Centroid_X", "Centroid_Y", "Centroid_Z")
    mol.dat <- mol.dat[,rel.cols]
    colnames(mol.dat) <- c("gene", "cell", "x", "y", "z")
    
    # solve overlap (some cells in molecule data not
    # in segmentation table, and vice versa) 
    mol.dat <- subset(mol.dat, cell %in% spe$cell_id)
    ucell <- unique(mol.dat$cell)
    spe <- subset(spe, , spe$cell_id %in% ucell)
    
    # replace long cell barcodes by integer index
    # to speed up bumpy matrix creation
    ind <- match(mol.dat$cell, spe$cell_id)
    mol.dat$cell <- ind
    mol.dat$cell <- factor(mol.dat$cell, levels = seq_len(ncol(spe)))
    
    # there are three types of features: 
    # (1) digital (with molecules), combinatorial smFISH imaging
    # (2) analog (no molecules), non-combinatorial sequential FISH
    # (3) blanks (negative controls)

    # store molecules for blanks in the blank altExp
    blanks <- paste("Blank", 1:5, sep = "-")
    ind <- mol.dat$gene %in% blanks
    bmol.dat <- mol.dat[ind,]
    mol.dat <- mol.dat[!ind,] 
    bmol <- BumpyMatrix::splitAsBumpyMatrix(bmol.dat[, c("x", "y", "z")], 
                                            row = bmol.dat$gene,
                                            col = bmol.dat$cell)   
    rownames(bmol) <- paste("Blank", 1:5, sep = "_")
    colnames(bmol) <- NULL 
    SummarizedExperiment::assay(
        SingleCellExperiment::altExps(spe)$Blank, "molecules") <- bmol   
    
    # divide between 
    # (1) analog (no molecules), non-combinatorial sequential FISH 
    # (2) digital (with molecules), combinatorial smFISH imaging
    spe <- .separateAnalogs(spe, mol.dat)
    mol <- BumpyMatrix::splitAsBumpyMatrix(mol.dat[, c("x", "y", "z")], 
                                           row = mol.dat$gene,
                                           col = mol.dat$cell)
    colnames(mol) <- NULL 
    SummarizedExperiment::assay(spe, "molecules") <- mol    
    return(spe)
}

context("Hypothalamus")

checkSPE <- function(spe)
{
    # check overall object
    expect_is(spe, "SpatialExperiment")
    expect_true(nrow(spe) > 130)
    expect_true(ncol(spe) > 73600)

    # check colData
    cdat.cols <- c("cell_id", "sample_id", "sex", "behavior", "cell_class")
    expect_true(all(cdat.cols %in% colnames(colData(spe))))

    # check spatialCoords
    expect_equal(ncol(spatialCoords(spe)), 3) 
    expect_true(all(colnames(spatialCoords(spe)) == c("x", "y", "z")))
    expect_true(is.numeric(spatialCoords(spe)))
}


test_that("standard usage", {
    spe <- MouseHypothalamusMoffitt2018()
    checkSPE(spe)
    spl <- split(spatialCoords(spe)[,"x"], spatialCoords(spe)[,"z"])
    expect_equal(round(mean(spl[[1]])), 0)
    spl <- split(spatialCoords(spe)[,"y"], spatialCoords(spe)[,"z"])
    expect_equal(round(mean(spl[[1]])), 0)
})

test_that("center.coords = FALSE", {
    spe <- MouseHypothalamusMoffitt2018(center.coords = FALSE)
    checkSPE(spe)
    spl <- split(spatialCoords(spe)[,"x"], spatialCoords(spe)[,"z"])
    expect_false(round(mean(spl[[1]])) == 0)
    spl <- split(spatialCoords(spe)[,"y"], spatialCoords(spe)[,"z"])
    expect_false(round(mean(spl[[1]])) == 0)
})

#' MERFISH mouse ileum dataset from Petukhov et al., 2021
#' @description Obtain the MERFISH mouse ileum dataset from Petukhov et al., 2021
#' @details Spatial transcriptomics protocols based on in situ sequencing or 
#' multiplexed RNA fluorescent hybridization can reveal detailed tissue organization.
#' Distinguishing the boundaries of individual cells in such data is challenging.
#' Current segmentation methods typically approximate cells positions using nuclei
#' stains. 
#'
#' Petukhov et al., 2021, describe Baysor, a segmentation method,
#' which optimizes 2D or 3D cell boundaries considering joint likelihood of
#' transcriptional composition and cell morphology.
#' Baysor can also perform segmentation based on the detected transcripts alone.
#'
#' Petukhov et al., 2021, compare the results of Baysor segmentation (mRNA-only)
#' to the results of a deep learning-based segmentation method called Cellpose from
#' Stringer et al., 2021. Cellpose applies a machine learning framework for the
#' segmentation of cell bodies, membranes and nuclei from microscopy images.
#' 
#' The function allows to obtain segmented MERFISH mouse ileum data for both
#' segmentation methods.
#'
#' A note on storing images within a \code{\linkS4class{SpatialExperiment}}:
#' The default \code{use.images = TRUE} reduces the 9-frame z-stack images
#' for DAPI stain and Membrane Na+/K+ - ATPase fluorecense to single-frame
#' images (taking the first frame). For working with the 9-frame z-stack
#' images it is recommended to load the images individually from ExperimentHub.
#' @param segmentation character. Should be either \code{"baysor"} or
#' \code{"cellpose"}. Defaults to \code{"baysor"}. See details.
#' @param use.images logical. Should DAPI and Membrane Na+/K+ - ATPase images
#' be loaded into memory and annotated to the \code{\link{imgData}} slot of
#' the returned \code{\linkS4class{SpatialExperiment}}? Defaults to \code{TRUE}.
#' See details.
#' @param use.polygons logical. Should polygon cell boundaries be annotated
#' to the \code{\link{metadata}} of the returned \code{\linkS4class{SpatialExperiment}}? 
#' Defaults to \code{TRUE}. Only available for Baysor segmentation.
#' @return An object of class \code{\linkS4class{SpatialExperiment}}.
#' @references Petukhov et al. (2021) Cell segmentation in imaging-based
#' spatial transcriptomics. Nat Biotechnol, 40(3), 345-54. 
#'
#' Stringer et al. (2021) Cellpose: a generalist algorithm for cellular
#' segmentation.  Nat Methods, 18(1), 100-6.  
#' @source \url{https://doi.org/10.5061/dryad.jm63xsjb2}
#' @examples spe <- MouseIleumPetukhov2021()
#' @export
MouseIleumPetukhov2021 <- function(segmentation = c("baysor", "cellpose"),
                                   use.images = TRUE,
                                   use.polygons = TRUE)
{
    segmentation <- match.arg(segmentation)

    # obtain records from ExperimentHub
    eh <- ExperimentHub::ExperimentHub()
    recs <- AnnotationHub::query(eh, c("MERFISH", "Petukhov2021"))
    
    # setup progress bar
    counter <- 0
    pb <- NULL
    if(interactive())
    {
        nr.items <- length(recs) - 2
        if(!use.images) nr.items <- nr.items - 2
        if(segmentation == "baysor" && !use.polygons) nr.items <- nr.items - 1
        if(segmentation == "cellpose") nr.items <- nr.items - 3
        pb <- txtProgressBar(counter, nr.items, style = 3)
    }

    # (1) image data
    if(use.images)
    {
        img.dat <- .getImageData(recs, pb, counter)
        if(interactive())
        {
            pb <- img.dat$pb
            counter <- img.dat$counter
        }
    }

    # (2) counts
    suffix <- paste(segmentation, "counts", sep = "_")
    counts <- .getResource(recs, suffix)
    ass.dat <- list(counts = counts) 
    if(interactive())
    {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }

    # (3) colData        
    suffix <- paste(segmentation, "coldata", sep = "_")
    col.dat <- .getResource(recs, suffix)
    scn <- c("x", "y", "z")
    if(interactive())
    {
        counter <- counter + 1
        setTxtProgressBar(pb, counter)
    }

    # for baysor: add molecules, segmentation, and polygons
    if(segmentation == "baysor")
    {
        # (4) molecule data
        mol.dat <- .getResource(recs, "_molecules")
        if(interactive())
        {
            counter <- counter + 1
            setTxtProgressBar(pb, counter)
        }    

        # (5) segmentation
        mol <- .getSegmentation(recs, mol.dat)
        ass.dat <- c(ass.dat, molecules = mol)
        scn <- scn[seq_len(2)]    
        if(interactive())
        {
            counter <- counter + 1
            setTxtProgressBar(pb, counter)
        }
    }
    
    # create SpatialExperiment object
    spe <- SpatialExperiment::SpatialExperiment(assays = ass.dat,
                                                colData = col.dat,
                                                sample_id = "ileum",
                                                spatialCoordsNames = scn)
    if(use.images) SpatialExperiment::imgData(spe) <- img.dat$img.dat

    # (6) polygons
    if(use.polygons && segmentation == "baysor")
    {
        metadata(spe)$polygons <- .annotatePolygons(recs)
        if(interactive())
        {
            counter <- counter + 1
            setTxtProgressBar(pb, counter)
        }
    }

    if(interactive()) close(pb)
    return(spe)
}

.getImageData <- function(recs, pb, counter)
{
    # (a) DAPI images
    dapi.img <- .getResource(recs, "_dapi")
    dapi.img <- as.raster(dapi.img)
    dapi.img <- SpatialExperiment::SpatialImage(dapi.img)    
    dapi.img <- SpatialExperiment::mirrorImg(dapi.img, "h")
    counter <- counter + 1
    if(interactive()) setTxtProgressBar(pb, counter)

    # (b) Membrane marker images
    mem.img <- .getResource(recs, "_membrane")
    mem.img <- as.raster(mem.img)
    mem.img <- SpatialExperiment::SpatialImage(mem.img)    
    mem.img <- SpatialExperiment::mirrorImg(mem.img, "h")
    counter <- counter + 1
    if(interactive()) setTxtProgressBar(pb, counter)

    img.list <- list(dapi = dapi.img, mem = mem.img)
    img.data <- S4Vectors::DataFrame(
                            sample_id = "ileum",
                            image_id = c("dapi", "membrane"),
                            data = I(img.list),
                            scaleFactor = NA_real_)
    return(list(img.dat = img.data, pb = pb, counter = counter))
}

.getSegmentation <- function(recs, mol.dat)
{
        seg <- .getResource(recs, "_segmentation")
        ind <- match(seg$molecule_id, mol.dat$molecule_id)
        rel.cols <- c("gene", "x_pixel", "y_pixel", "z_pixel")
        seg.add <- mol.dat[ind, rel.cols]
        colnames(seg.add)[2:4] <- c("x", "y", "z")
        seg <- cbind(seg, seg.add)
        mol <- BumpyMatrix::splitAsBumpyMatrix(seg[, c("x", "y", "z")], 
                                               row = seg$gene, col = seg$cell)
        return(mol)
}

.annotatePolygons <- function(recs)
{
    poly <- .getResource(recs, "_polygons")
    return(poly)
}

context("Ileum")

checkSPE <- function(spe, 
                     seg = c("baysor", "cellpose"),
                     images = TRUE,
                     polygons = TRUE)
{
    # check overall object
    expect_is(spe, "SpatialExperiment")

    # check dimensions
    seg <- match.arg(seg)
    expect_equal(nrow(spe), 241) 
    expect_equal(ncol(spe), ifelse(seg == "baysor", 5800, 8439))
        
    # check colData
    cdat.cols <- c("sample_id", "leiden_final")
    expect_true(all(cdat.cols %in% colnames(colData(spe))))

    # check spatialCoords
    expect_equal(ncol(spatialCoords(spe)), ifelse(seg == "baysor", 2, 3)) 
    expect_true(all(colnames(spatialCoords(spe))[1:2] == c("x", "y")))
    expect_true(is.numeric(spatialCoords(spe)))

    # check images
    if(images)
    {
        expect_equal(ncol(imgData(spe)), 4)
        expect_equal(nrow(imgData(spe)), 2)
        expect_true(all(imgData(spe)$image_id == c("dapi", "membrane")))
        expect_is(imgData(spe)$data$dapi, "LoadedSpatialImage")
    }

    # check polygons
    if(seg == "baysor" && polygons)
    {
        expect_true("polygons" %in% names(metadata(spe)))    
        expect_is(metadata(spe)$polygons, "matrix")
        expect_equal(mode(metadata(spe)$polygons), "numeric")
        expect_equal(ncol(metadata(spe)$polygons), 4)
        pcols <- c("z", "cell", "x", "y")
        expect_true(all(colnames(metadata(spe)$polygons) == pcols))
    }
}

test_that("standard usage", {
    spe <- MouseIleumPetukhov2021()
    checkSPE(spe)
})

test_that("segmentation = cellpose", {
    spe <- MouseIleumPetukhov2021(segmentation = "cellpose", use.images = FALSE)
    checkSPE(spe, seg = "cellpose", images = FALSE)
})

test_that("use.images = FALSE", {
    spe <- MouseIleumPetukhov2021(use.images = FALSE)
    checkSPE(spe, images = FALSE)
})

test_that("use.polygons = FALSE", {
    spe <- MouseIleumPetukhov2021(use.images = FALSE, use.polygons = FALSE)
    checkSPE(spe, images = FALSE, polygons = FALSE)
})

#' Plot raster image
#' @description Small helper function to plot a raster image.
#' @param img a raster object representing a bitmap image.
#' @return A ggplot object.
#' @examples
#'  hgrid <- hcl(0, 80, seq(50, 80, 10))
#'  img <- as.raster(matrix(hgrid, nrow = 4, ncol = 5))
#'  plotRasterImage(img)
#' @export
plotRasterImage <- function(img)
{
    if(!requireNamespace("grid"))
        stop("Please install the 'grid' package to use 'plotRasterImage'")
    if(!requireNamespace("ggplot2"))
        stop("Please install the 'ggplot2' package to use 'plotRasterImage'")

    grb <- grid::rasterGrob(img,
                      interpolate = FALSE,
                      width = grid::unit(1, "npc"),
                      height = grid::unit(1, "npc"))
    p <- ggplot2::ggplot() + 
         ggplot2::annotation_custom(grob = grb,
                           xmin = 0,
                           xmax = ncol(grb$raster),
                           ymin = 0,
                           ymax = nrow(grb$raster)) + 
        ggplot2::coord_fixed(xlim = c(0, ncol(grb$raster)),
                             ylim = c(0, nrow(grb$raster)))
    return(p)
}

#' Plot spatial image with data overlay
#' @description A helper function to overlay data onto a spatial image.
#' @param df A \code{data.frame} storing the data to plot.
#' @param col character. A column of \code{df} to use for overlay onto the image.
#' @param img a raster object representing a bitmap image.
#' @return A ggplot.
#' @examples 
#'  gene <- rep(c("Cd44", "Cd8b1", "Cd79b"), each = 2)
#'  x <- c(1693, 1701, 1820, 3188, 1631, 1881)
#'  y <- c(1831, 1666, 1855, 6612, 1533, 942)
#'  df <- data.frame(gene = gene, x = x, y = y)
#'  plotXY(df, "gene")
#' @export
plotXY <- function(df, col, img = NULL)
{
    if(!requireNamespace("ggpubr"))
        stop("Please install the 'ggpubr' package to use 'plotXY'")

    .data <- x <- y <- NULL
    if(!is.null(img)) p <- plotRasterImage(img)
    else p <- ggplot2::ggplot()
    p <- p + ggplot2::geom_point(data = df,
                        shape = 16,
                        size = 0.5,
                        ggplot2::aes(x, y, col = .data[[col]])) +
                        ggplot2::theme_void()
    if(is.numeric(df[[col]])) p + ggplot2::scale_color_viridis_c()
    else
    {
        ucsc <- function(n) ggpubr::get_palette("ucscgb", n)
        cols <- ucsc(length(levels(factor(df[[col]]))))
        p + ggplot2::theme(legend.key.size = grid::unit(0.5, "lines")) +
            ggplot2::scale_color_manual(values = cols) +
            ggplot2::guides(color = ggplot2::guide_legend(override.aes = list(size = 2)))
    }
}

#' Plot a tabset 
#' @description Plot a tabset of colData annotations of one or more
#' SpatialExperiment objects over an image.
#' @param spe.list A named \code{list} of \code{\linkS4class{SpatialExperiment}}
#' objects.
#' @param img a raster object representing a bitmap image.
#' @return None. Produces a tabset for rendering with \code{rmarkdown}.
#' @examples
#'  # create simulated data as described in the SpatialExperiment man page
#'  n <- 1000; ng <- 50; nc <- 20
#'  x <- runif(n)
#'  y <- runif(n)
#'
#'  # assign each molecule to some gene-cell pair
#'  gs <- paste0("gene", seq(ng))
#'  cs <- paste0("cell", seq(nc))
#'  gene <- sample(gs, n, TRUE)
#'  cell <- sample(cs, n, TRUE)
#'
#'  # generate molecule coordinates
#'  df <- data.frame(gene, cell, x, y)
#'  df$gene <- factor(df$gene, gs)
#'  df$cell <- factor(df$cell, cs)
#'
#'  mol <- BumpyMatrix::splitAsBumpyMatrix(
#'          df[, c("x", "y")],
#'          row = df$gene, column = df$cell)
#'
#'  # generate gene x cell molecule count matrix
#'  y <- with(df, table(gene, cell))
#'  y <- as.matrix(unclass(y))
#'
#'  # construct SpatialExperiment
#'  spe <- SpatialExperiment(assays = list(counts = y, molecules = mol))
#' 
#'  # add simulated cell centroids
#'  s <- cbind(x = runif(20), y = runif(20))    
#'  spatialCoords(spe) <- s 
#'
#'  # add simulated cell type and cell cycle annotation
#'  ct <- c("ct1", "ct2", "ct3")
#'  cc <- c("G1", "G2", "S", "M") 
#'  spe$type <- sample(ct, ncol(spe), replace = TRUE)
#'  spe$cycle <- sample(cc, ncol(spe), replace = TRUE)
#'
#'  # create an example image
#'  hgrid <- hcl(0, 80, seq(50, 80, 10))
#'  img <- as.raster(matrix(hgrid, nrow = 4, ncol = 5))
#'
#'  # plotTabset
#'  spe.list <- list(myseg = spe)
#'  plotTabset(spe.list, img)  
#' @export
plotTabset <- function(spe.list, img)
{
    for (n in names(spe.list))
    {
        cat("### ", n, " {.tabset} \n\n")
        spe <- spe.list[[n]]
        df <- data.frame(SummarizedExperiment::colData(spe),
                         SpatialExperiment::spatialCoords(spe))
        rel.cols <- c("sample_id", "cell", "seg", "x", "y")
        rel.cols <- setdiff(names(df), rel.cols)
        # ...plot each variable
        for (col in rel.cols)
        {
            p <- plotXY(df, col, img)
            cat("#### ", col, '{-}', "\n")
            print(p)
            cat("\n\n")
        }
    }
}

#' Add holes to polygons
#' @description Add holes to a `data.frame` of cell polygon coordinates 
#' @param poly A \code{data.frame} storing cell polygon coordinates.
#' Expected columns include \itemize{
#' \item \code{"cell"} storing the cell ID,
#' \item \code{"x"} storing x-coordinates of the polygon corners,
#' \item \code{"y"} storing the y-coordinates of the polygon corners.}
#' @return A \code{data.frame}
#' @export
#' @examples
#'      x <- c(2053, 2053, 2053, 2056, 2059, 2059)
#'      y <- c(51, 54, 57, 57, 57, 54)
#'      poly <- data.frame(cell = 1, x = x, y = y)
#'      poly <- addHolesToPolygons(poly)
addHolesToPolygons <- function(poly)
{
    .f <- function(df) 
    {
        df$x <- df$x + 0.5 * (mean(df$x) - df$x)
        df$y <- df$y + 0.5 * (mean(df$y) - df$y)
        return(df)
    }
    spl <- split(poly, poly$cell)
    dl <- lapply(spl, .f)
    holes <- do.call(rbind, dl)
    poly$subid <- 1L
    holes$subid <- 2L
    poly <- rbind(poly, holes)
    return(poly)
}

.getResource <- function(recs, suffix)
{
    suffix <- paste0(suffix, "$")
    ind <- grep(suffix, recs$title)
    id <- recs$ah_id[ind]
    suppressMessages(rec <- recs[[id]])
    return(rec)
}

# A script describing the steps involved in making the data object(s). This 
# includes where the original data were downloaded from, pre-processing, and
# how the final R object was made. Include a description of any steps performed
# outside of R with third party software. Output of the script should be files
# on disk ready to be pushed to S3. If data are to be hosted on a personal web 
# site instead of S3, this file should explain any manipulation of the data 
# prior to hosting on the web site. For data hosted on a public web site with 
# no prior manipulation this file is not needed.

# A script to make the metadata.csv file located in inst/extdata of the package.
# See ?AnnotationHubData::makeAnnotationHubMetadata for a description of the 
# metadata.csv file, expected fields and data types. This 
# AnnotationHubData::makeAnnotationHubMetadata() function can be used to 
# validate the metadata.csv file before submitting the package.

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL ## Related to https://stat.ethz.ch/pipermail/bioc-devel/2020-April/016656.html
)

## ----message = FALSE----------------------------------------------------------
library(MerfishData)
library(ExperimentHub)
library(ggplot2)
library(grid)

## -----------------------------------------------------------------------------
eh <- ExperimentHub()
AnnotationHub::query(eh, c("MerfishData", "ileum"))

## ----mol-data, message = FALSE, warning = FALSE-------------------------------
mol.dat <- eh[["EH7543"]]
dim(mol.dat)
head(mol.dat)
length(unique(mol.dat$gene))

## ----dapi-img, message = FALSE, warning = FALSE, fig.height = 10--------------
dapi.img <- eh[["EH7544"]]
dapi.img
plot(dapi.img, all = TRUE)
plot(dapi.img, frame = 1)

## ----mem-img, message = FALSE, warning = FALSE, fig.height = 10---------------
mem.img <- eh[["EH7545"]]
mem.img
plot(mem.img, all = TRUE)
plot(mem.img, frame = 1)

## ----baysor-spe, message = FALSE----------------------------------------------
spe.baysor <- MouseIleumPetukhov2021(segmentation = "baysor")
spe.baysor

## ----baysor-spe-show----------------------------------------------------------
assay(spe.baysor, "counts")[1:5,1:5]
assay(spe.baysor, "molecules")["Acsl1",5]
colData(spe.baysor)
head(spatialCoords(spe.baysor))
imgData(spe.baysor)

## ----cellpose-spe, message = FALSE--------------------------------------------
spe.cellpose <- MouseIleumPetukhov2021(segmentation = "cellpose",
                                       use.images = FALSE)
spe.cellpose

## ----cellpose-spe-show--------------------------------------------------------
assay(spe.cellpose, "counts")[1:5,1:5]
colData(spe.cellpose)
head(spatialCoords(spe.cellpose))

## ----fig.width = 6, fig.height = 4--------------------------------------------
seg <- rep(c("baysor", "cellpose"), c(ncol(spe.baysor), ncol(spe.cellpose)))
ns <- table(seg, c(spe.baysor$leiden_final, spe.cellpose$leiden_final))
df <- as.data.frame(ns, responseName = "n_cells")
colnames(df)[2] <- "leiden_final"
ggplot(df, aes(
    reorder(leiden_final, n_cells), n_cells, fill = seg)) +
    geom_bar(stat = "identity", position = "dodge") +
    xlab("") +
    ylab("Number of cells") + 
    theme_bw() +
    theme(
        panel.grid.minor = element_blank(),
        axis.text.x = element_text(angle = 45, hjust = 1))

## -----------------------------------------------------------------------------
mem.img <- imgRaster(spe.baysor, image_id = "membrane")

## ----viz-cells, results = "asis", fig.height = 8, warning = FALSE-------------
spe.list <- list(Baysor = spe.baysor, Cellpose = spe.cellpose)
plotTabset(spe.list, mem.img)

## ----fig.height = 8-----------------------------------------------------------
gs <- grep("^Cd", unique(mol.dat$gene), value = TRUE)
ind <- mol.dat$gene %in% gs
rel.cols <- c("gene", "x_pixel", "y_pixel")
sub.mol.dat <- mol.dat[ind, rel.cols]
colnames(sub.mol.dat)[2:3] <- sub("_pixel$", "", colnames(sub.mol.dat)[2:3])
plotXY(sub.mol.dat, "gene", mem.img)

## -----------------------------------------------------------------------------
poly <- metadata(spe.baysor)$polygons
poly <- as.data.frame(poly)
poly.z1 <- subset(poly, z == 1)

## -----------------------------------------------------------------------------
poly.z1 <- addHolesToPolygons(poly.z1)

## ----fig.height = 8-----------------------------------------------------------
p <- plotRasterImage(mem.img)
p <- p + geom_polygon(
            data = poly.z1,
            aes(x = x, y = y, group = cell, subgroup = subid), 
            fill = "lightblue")
p + theme_void()

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL 
)

## ----lib, message = FALSE-----------------------------------------------------
library(MerfishData)
library(ExperimentHub)
library(ggplot2)
library(scater)
library(terra)

## ----eh-----------------------------------------------------------------------
eh <- ExperimentHub()
AnnotationHub::query(eh, c("MerfishData", "Cadinu2024"))

## ----data, message = FALSE----------------------------------------------------
spe <- MouseColonIbdCadinu2024()
spe

## ----datacomp-----------------------------------------------------------------
counts(spe)[1:5,1:5]
logcounts(spe)[1:5,1:5]
colData(spe)
head(spatialCoords(spe))

## ----tiers--------------------------------------------------------------------
table(spe$tier1)
table(spe$tier2)
table(spe$tier3)

## ----stype--------------------------------------------------------------------
table(spe$sample_type)

## ----fig1c, message=FALSE-----------------------------------------------------
plotReducedDim(spe, "UMAP", colour_by = "tier1", 
               scattermore = TRUE, rasterise = TRUE) +
    scale_color_manual(values = metadata(spe)$colors_tier1) + 
    labs(color = "cell type") 

## ----fig1d--------------------------------------------------------------------
# Filter spatial coordinates for the selected slice ID
slice_coords <- spatialCoords(spe)[spe$mouse_id == "082421_D0_m6" &
                                   spe$sample_type == "Healthy" &
                                   spe$technical_repeat_number == "1" &
                                   spe$slice_id == "2", ]
# Rotate coordinates to have them match the rotation in the paper
slice_coords_vec <- vect(slice_coords, type = "points")
slice_coords_r <- spin(slice_coords_vec, 180)
slice_c <- as.data.frame(slice_coords_r, geom = "XY")
slice_df <- data.frame(x = slice_c[,1],
                       y = slice_c[,2],
                       tier1 = spe$tier1[spe$mouse_id == "082421_D0_m6" &
                                         spe$sample_type == "Healthy" &
                                         spe$technical_repeat_number == "1" &
                                         spe$slice_id == "2"])
# Plot
ggplot(data = slice_df, aes(x = x, y = y, color = tier1)) +
    geom_point(shape = 19, size = 0.5) +
    scale_color_manual(values = metadata(spe)$colors_tier1) +
    guides(colour = guide_legend(override.aes = list(size = 2))) + 
    labs(color = "cell type") +
    theme_bw(10)

## ----fig.height = 8, fig.width = 10-------------------------------------------
# Filter spatial coordinates for the selected slice ID
slice_coords <- spatialCoords(spe)[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2"), ]


slice_df <- data.frame(x = scale(slice_coords[, 1], scale = FALSE),
                       y = scale(slice_coords[, 2], scale = FALSE),
                       tier1 = spe$tier1[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2")],
                       day = spe$sample_type[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                    (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2")])

slice_df$day <- factor(slice_df$day, levels = c("Healthy", "DSS3", "DSS9", "DSS21"))

ggplot(data = slice_df, aes(x = x, y = y, color = tier1)) +
    geom_point(shape = 19, size = 0.5) +
    scale_color_manual(values = metadata(spe)$colors_tier1) +
    theme_bw(10) + guides(colour = guide_legend(override.aes = list(size=2)))+ 
    labs(color = "cell type") +
    facet_wrap( ~ day, ncol = 2, nrow = 2, scales = "free")

## ----fig.height = 8, fig.width = 10-------------------------------------------
slice_df$tier2 <- spe$tier2[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2")]
slice_df$color <- ifelse(slice_df$tier1 == "Epithelial", 
                         as.character(slice_df$tier2), "grey")

slice_df$color <- factor(slice_df$color)

colored_df <- slice_df[slice_df$tier1 == "Epithelial", ]

ggplot() +
  geom_point(data = slice_df, aes(x = x, y = y), color = "grey", 
             shape = 19, size = 0.1) +
  geom_point(data = colored_df, aes(x = x, y = y, color = tier2), 
             shape = 19, size = 0.1) +
  scale_color_manual(values = metadata(spe)$colors_tier2) +
  theme_bw(10) +
  guides(colour = guide_legend(override.aes = list(size = 2))) +
  labs(color = 'cell type') +
  facet_wrap(~ day, ncol = 2, scales = "free")

## ----fig.height = 8, fig.width = 10-------------------------------------------
slice_df$color <- ifelse(slice_df$tier1 == "Immune", 
                         as.character(slice_df$tier2),
                         "grey")
slice_df$color <- factor(slice_df$color)
colored_df <- subset(slice_df, tier1 == "Immune")

p <- ggplot() +
  geom_point(data = slice_df, aes(x = x, y = y), color = "grey", 
             shape = 19, size = 0.1) +
  geom_point(data = colored_df, aes(x = x, y = y, color = tier2), 
             shape = 19, size = 0.1) +
  scale_color_manual(values = metadata(spe)$colors_tier2) +
  theme_bw(10) +
  guides(colour = guide_legend(override.aes = list(size = 2))) +
  labs(color = 'cell type') +
  facet_wrap(~ day, ncol = 2, scales = "free")

p

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

---
title: "Import and representation of MERFISH mouse colon IBD data"
author: 
  - name: Daniela Corbetta    
    affiliation: Department of Statistical Sciences, University of Padova
  - name: Ludwig Geistlinger    
    affiliation: Center for Computational Biomedicine, Harvard Medical School
  - name: Tyrone Lee  
    affiliation: Center for Computational Biomedicine, Harvard Medical School
  - name: Jeffrey Moffitt
    affiliation: Department of Microbiology, Harvard Medical School
  - name: Robert Gentleman
    affiliation: Center for Computational Biomedicine, Harvard Medical School
output:
  BiocStyle::html_document:
    self_contained: yes 
    toc: true
    toc_float: true
    toc_depth: 2
    code_folding: show
date: "`r doc_date()`"
vignette: >
  % \VignetteIndexEntry{Mouse colon ibd}
  % \VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL 
)
```

# Setup

After the installation, we proceed by loading the package and additional packages
used in the vignette.

```{r lib, message = FALSE}
library(MerfishData)
library(ExperimentHub)
library(ggplot2)
library(scater)
library(terra)
```

# Data

Gut inflammation involves contributions from immune and non-immune cells,
whose interactions are shaped by the spatial organization of the healthy gut and 
its remodeling during inflammation.
The crosstalk between fibroblasts and immune cells is an important axis in this 
process, but our understanding has been challenged by incomplete cell-type 
definition and biogeography.

To address this challenge, 
[Cadinu et al., 2024](https://doi.org/10.1016/j.cell.2024.03.013) 
used multiplexed error-robust
fluorescence in situ hybridization
(MERFISH) to profile the expression of 943 genes in 1.35 million cells imaged
across the onset and recovery from a mouse colitis model. To assign RNAs to 
individual cells, they used [Baysor](https://github.com/kharchenkolab/Baysor).
They identified diverse cell populations, charted their
spatial organization, and revealed their polarization or recruitment in
inflammation.

This vignette demonstrates how to obtain the MERFISH mouse IBD colon dataset 
from [Cadinu et al., 2024](https://doi.org/10.1016/j.cell.2024.03.013) 
from Bioconductor's [ExperimentHub](https://bioconductor.org/packages/ExperimentHub).

The data was obtained from the 
[datadryad data publication](https://doi.org/10.5061/dryad.rjdfn2zh3).

```{r eh}
eh <- ExperimentHub()
AnnotationHub::query(eh, c("MerfishData", "Cadinu2024"))
```

## Segmented data

It is also possible to obtain the data in a [SpatialExperiment](https://bioconductor.org/packages/SpatialExperiment), which 
integrates experimental data and cell metadata, and provides designated 
accessors for the spatial coordinates. 

```{r data, message = FALSE}
spe <- MouseColonIbdCadinu2024()
spe
```

Inspect the data components:

```{r datacomp}
counts(spe)[1:5,1:5]
logcounts(spe)[1:5,1:5]
colData(spe)
head(spatialCoords(spe))
```

The dataset includes cell type labels with three levels of granularity 
(variables `tier1`, `tier2`, `tier3` in the `colData`).

```{r tiers}
table(spe$tier1)
table(spe$tier2)
table(spe$tier3)
```

The data have been collected before the insurgence of colitis 
(`sample_type="Healthy"`) and after some time intervals (3 days, 9 days, 21 days).

```{r stype}
table(spe$sample_type)
```

# Visualization

## Reduced dimensions

Replicate Fig. 1C of the [paper](https://doi.org/10.1016/j.cell.2024.03.013), to 
visualize cell types in the UMAP space:

```{r fig1c, message=FALSE}
plotReducedDim(spe, "UMAP", colour_by = "tier1", 
               scattermore = TRUE, rasterise = TRUE) +
    scale_color_manual(values = metadata(spe)$colors_tier1) + 
    labs(color = "cell type") 
```

## Spatial organization

We can also replicate Fig 1.D, to see the spatial distribution of cell types
in one slide:

```{r fig1d}
# Filter spatial coordinates for the selected slice ID
slice_coords <- spatialCoords(spe)[spe$mouse_id == "082421_D0_m6" &
                                   spe$sample_type == "Healthy" &
                                   spe$technical_repeat_number == "1" &
                                   spe$slice_id == "2", ]
# Rotate coordinates to have them match the rotation in the paper
slice_coords_vec <- vect(slice_coords, type = "points")
slice_coords_r <- spin(slice_coords_vec, 180)
slice_c <- as.data.frame(slice_coords_r, geom = "XY")
slice_df <- data.frame(x = slice_c[,1],
                       y = slice_c[,2],
                       tier1 = spe$tier1[spe$mouse_id == "082421_D0_m6" &
                                         spe$sample_type == "Healthy" &
                                         spe$technical_repeat_number == "1" &
                                         spe$slice_id == "2"])
# Plot
ggplot(data = slice_df, aes(x = x, y = y, color = tier1)) +
    geom_point(shape = 19, size = 0.5) +
    scale_color_manual(values = metadata(spe)$colors_tier1) +
    guides(colour = guide_legend(override.aes = list(size = 2))) + 
    labs(color = "cell type") +
    theme_bw(10)
```


We can compare the spatial organization of cells before the insurgence
of colitis and at the considered timepoints (after 3, 9, and 21 days):

```{r, fig.height = 8, fig.width = 10}
# Filter spatial coordinates for the selected slice ID
slice_coords <- spatialCoords(spe)[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2"), ]


slice_df <- data.frame(x = scale(slice_coords[, 1], scale = FALSE),
                       y = scale(slice_coords[, 2], scale = FALSE),
                       tier1 = spe$tier1[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2")],
                       day = spe$sample_type[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                    (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2")])

slice_df$day <- factor(slice_df$day, levels = c("Healthy", "DSS3", "DSS9", "DSS21"))

ggplot(data = slice_df, aes(x = x, y = y, color = tier1)) +
    geom_point(shape = 19, size = 0.5) +
    scale_color_manual(values = metadata(spe)$colors_tier1) +
    theme_bw(10) + guides(colour = guide_legend(override.aes = list(size=2)))+ 
    labs(color = "cell type") +
    facet_wrap( ~ day, ncol = 2, nrow = 2, scales = "free")
```

We can also restrict the analysis to a specific macro-group to see the different
distribution of Tier2 cell types. See an example the different composition
of epithelial cells:

```{r, fig.height = 8, fig.width = 10}
slice_df$tier2 <- spe$tier2[(spe$mouse_id == "062921_D0_m3a" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "092421_D3_m1" &
                                     spe$slice_id=="2")|
                                     (spe$mouse_id == "062221_D9_m3" &
                                     spe$slice_id=="2") |
                                     (spe$mouse_id == "082421_D21_m1" &
                                     spe$slice_id=="2")]
slice_df$color <- ifelse(slice_df$tier1 == "Epithelial", 
                         as.character(slice_df$tier2), "grey")

slice_df$color <- factor(slice_df$color)

colored_df <- slice_df[slice_df$tier1 == "Epithelial", ]

ggplot() +
  geom_point(data = slice_df, aes(x = x, y = y), color = "grey", 
             shape = 19, size = 0.1) +
  geom_point(data = colored_df, aes(x = x, y = y, color = tier2), 
             shape = 19, size = 0.1) +
  scale_color_manual(values = metadata(spe)$colors_tier2) +
  theme_bw(10) +
  guides(colour = guide_legend(override.aes = list(size = 2))) +
  labs(color = 'cell type') +
  facet_wrap(~ day, ncol = 2, scales = "free")
```

```{r, fig.height = 8, fig.width = 10}
slice_df$color <- ifelse(slice_df$tier1 == "Immune", 
                         as.character(slice_df$tier2),
                         "grey")
slice_df$color <- factor(slice_df$color)
colored_df <- subset(slice_df, tier1 == "Immune")

p <- ggplot() +
  geom_point(data = slice_df, aes(x = x, y = y), color = "grey", 
             shape = 19, size = 0.1) +
  geom_point(data = colored_df, aes(x = x, y = y, color = tier2), 
             shape = 19, size = 0.1) +
  scale_color_manual(values = metadata(spe)$colors_tier2) +
  theme_bw(10) +
  guides(colour = guide_legend(override.aes = list(size = 2))) +
  labs(color = 'cell type') +
  facet_wrap(~ day, ncol = 2, scales = "free")

p
```

# Interactive exploration

The MERFISH mouse colon IBD dataset is part of the
[gallery of publicly available MERFISH datasets](https://moffittlab.connect.hms.harvard.edu/merfish/merfish_homepage.html).

This gallery consists of dedicated 
[iSEE](https://bioconductor.org/packages/iSEE) and 
[Vitessce](http://vitessce.io/) instances, published on 
[Posit Connect](https://posit.co/products/enterprise/connect/), 
that enable the interactive exploration of different segmentations,
the expression of marker genes, and overlay of
cell metadata on a spatial grid or a microscopy image.

# SessionInfo

```{r sessionInfo}
sessionInfo()
```

---
title: "Import and representation of MERFISH mouse ileum data"
author: 
  - name: Ludwig Geistlinger    
    affiliation: Center for Computational Biomedicine, Harvard Medical School
  - name: Tyrone Lee  
    affiliation: Center for Computational Biomedicine, Harvard Medical School
  - name: Jeffrey Moffitt
    affiliation: Department of Microbiology, Harvard Medical School
  - name: Robert Gentleman
    affiliation: Center for Computational Biomedicine, Harvard Medical School
output:
  BiocStyle::html_document:
    self_contained: yes 
    toc: true
    toc_float: true
    toc_depth: 2
    code_folding: show
date: "`r doc_date()`"
vignette: >
  % \VignetteIndexEntry{Mouse ileum}
  % \VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL ## Related to https://stat.ethz.ch/pipermail/bioc-devel/2020-April/016656.html
)
```

# Setup

```{r, message = FALSE}
library(MerfishData)
library(ExperimentHub)
library(ggplot2)
library(grid)
```

# Data

Spatial transcriptomics protocols based on in situ sequencing or multiplexed
RNA fluorescent hybridization can reveal detailed tissue organization.
However, distinguishing the boundaries of individual cells in such data is
challenging. Current segmentation methods typically approximate cells positions
using nuclei stains.

[Petukhov et al., 2021](https://doi.org/10.1038/s41587-021-01044-w), 
describe 
[Baysor](https://github.com/kharchenkolab/Baysor),
a segmentation method, which optimizes
2D or 3D cell boundaries considering joint likelihood of transcriptional composition
and cell morphology. Baysor can also perform segmentation based on the detected
transcripts alone.

[Petukhov et al., 2021](https://doi.org/10.1038/s41587-021-01044-w), 
compare the results of Baysor segmentation
(mRNA-only) to the results of a deep learning-based segmentation
method called 
[Cellpose](https://github.com/MouseLand/cellpose) from 
[Stringer et al., 2021](https://doi.org/10.1038/s41592-020-01018-x). 
Cellpose applies a machine learning framework for the segmentation of cell
bodies, membranes and nuclei from microscopy images.

[Petukhov et al., 2021](https://doi.org/10.1038/s41587-021-01044-w) apply
Baysor and Cellpose to MERFISH data from cryosections of mouse ileum. 
The MERFISH encoding probe library was designed to target 241 genes, including
previously defined markers for the majority of gut cell types.

Def. ileum: the final and longest segment of the small intestine.

Samples were also stained with anti-Na+/K+-ATPase primary antibodies,
oligo-labeled secondary antibodies and DAPI. MERFISH measurements across
multiple fields of view and nine *z* planes were performed to provide
a volumetric reconstruction of the distribution of the targeted
mRNAs, the cell boundaries marked by Na+/K+-ATPase IF and cell
nuclei stained with DAPI.

The data was obtained from the 
[datadryad data publication](https://doi.org/10.5061/dryad.jm63xsjb2). 

This vignette demonstrates how to obtain the MERFISH mouse ileum dataset from
[Petukhov et al., 2021](https://doi.org/10.1038/s41587-021-01044-w)
from Bioconductor's [ExperimentHub](https://bioconductor.org/packages/ExperimentHub).

```{r}
eh <- ExperimentHub()
AnnotationHub::query(eh, c("MerfishData", "ileum"))
```

## Raw data

mRNA molecule data: 820k observations for 241 genes

```{r mol-data, message = FALSE, warning = FALSE}
mol.dat <- eh[["EH7543"]]
dim(mol.dat)
head(mol.dat)
length(unique(mol.dat$gene))
```

Image data: 

1. [DAPI](https://en.wikipedia.org/wiki/DAPI) stain signal:

```{r dapi-img, message = FALSE, warning = FALSE, fig.height = 10}
dapi.img <- eh[["EH7544"]]
dapi.img
plot(dapi.img, all = TRUE)
plot(dapi.img, frame = 1)
```

2. Membrane Na+/K+ - ATPase immunofluorescence signal:

While total poly(A) and DAPI staining can provide feature-rich costains suitable
for segmentation in cell-sparse tissues such as the brain, such stains are not
as useful for segmentation in cellular-dense tissues.
To address this challenge, 
[Petukhov et al., 2021](https://doi.org/10.1038/s41587-021-01044-w)
developed protocols to combine immunofluorescence (IF) of a pan-cell-type cell
surface marker, the Na+/K+-ATPase, with MERFISH.

```{r mem-img, message = FALSE, warning = FALSE, fig.height = 10}
mem.img <- eh[["EH7545"]]
mem.img
plot(mem.img, all = TRUE)
plot(mem.img, frame = 1)
```

## Segmentation

It is also possible to obtain the data in a 
[SpatialExperiment](https://bioconductor.org/packages/SpatialExperiment), 
which integrates the segmented experimental data and cell metadata, and provides
designated accessors for the spatial coordinates and the image data.

### Baysor

Obtain dataset segmented with Baysor:

```{r baysor-spe, message = FALSE}
spe.baysor <- MouseIleumPetukhov2021(segmentation = "baysor")
spe.baysor
```

Inspect dataset:

```{r baysor-spe-show}
assay(spe.baysor, "counts")[1:5,1:5]
assay(spe.baysor, "molecules")["Acsl1",5]
colData(spe.baysor)
head(spatialCoords(spe.baysor))
imgData(spe.baysor)
```

### Cellpose

Obtain dataset segmented with Cellpose:

```{r cellpose-spe, message = FALSE}
spe.cellpose <- MouseIleumPetukhov2021(segmentation = "cellpose",
                                       use.images = FALSE)
spe.cellpose
```

Inspect dataset:

```{r cellpose-spe-show}
assay(spe.cellpose, "counts")[1:5,1:5]
colData(spe.cellpose)
head(spatialCoords(spe.cellpose))
```

### Segmentation cell counts (by cell type):

Here we inspect the difference in cell counts for the both segmentation methods,
stratified by cell type label obtained from leiden clustering and annotation by
marker gene expression:

```{r fig.width = 6, fig.height = 4}
seg <- rep(c("baysor", "cellpose"), c(ncol(spe.baysor), ncol(spe.cellpose)))
ns <- table(seg, c(spe.baysor$leiden_final, spe.cellpose$leiden_final))
df <- as.data.frame(ns, responseName = "n_cells")
colnames(df)[2] <- "leiden_final"
ggplot(df, aes(
    reorder(leiden_final, n_cells), n_cells, fill = seg)) +
    geom_bar(stat = "identity", position = "dodge") +
    xlab("") +
    ylab("Number of cells") + 
    theme_bw() +
    theme(
        panel.grid.minor = element_blank(),
        axis.text.x = element_text(angle = 45, hjust = 1))
```

# Visualization

For visualization purposes, we focus in the following on the first *z*-plane
of the membrane staining image.

```{r}
mem.img <- imgRaster(spe.baysor, image_id = "membrane")
```

## Cell metadata

Overlay cell type annotation as in Figure 6 of the 
[publication](https://doi.org/10.1038/s41587-021-01044-w).

```{r viz-cells, results = "asis", fig.height = 8, warning = FALSE}
spe.list <- list(Baysor = spe.baysor, Cellpose = spe.cellpose)
plotTabset(spe.list, mem.img)
```

## Marker gene expression

We can also overlay the individual molecules of selected marker genes such as 
the different cluster of differentiation genes assayed in the experiment: 

```{r, fig.height = 8}
gs <- grep("^Cd", unique(mol.dat$gene), value = TRUE)
ind <- mol.dat$gene %in% gs
rel.cols <- c("gene", "x_pixel", "y_pixel")
sub.mol.dat <- mol.dat[ind, rel.cols]
colnames(sub.mol.dat)[2:3] <- sub("_pixel$", "", colnames(sub.mol.dat)[2:3])
plotXY(sub.mol.dat, "gene", mem.img)
```

## Segmentation cell borders

Here, we illustrate segmentation borders for the first *z*-plane:

```{r}
poly <- metadata(spe.baysor)$polygons
poly <- as.data.frame(poly)
poly.z1 <- subset(poly, z == 1)
```

We add holes to the cell polygons:

```{r}
poly.z1 <- addHolesToPolygons(poly.z1)
```

Plot over membrane image:

```{r, fig.height = 8}
p <- plotRasterImage(mem.img)
p <- p + geom_polygon(
            data = poly.z1,
            aes(x = x, y = y, group = cell, subgroup = subid), 
            fill = "lightblue")
p + theme_void()
```

# Interactive exploration

The MERFISH mouse ileum dataset is part of the
[gallery of publicly available MERFISH datasets](https://moffittlab.connect.hms.harvard.edu/merfish/merfish_homepage.html).

This gallery consists of dedicated 
[iSEE](https://bioconductor.org/packages/iSEE) and 
[Vitessce](http://vitessce.io/) instances, published on 
[Posit Connect](https://posit.co/products/enterprise/connect/), 
that enable the interactive exploration of different segmentations,
the expression of marker genes, and overlay of
cell metadata on a spatial grid or a microscopy image.

# SessionInfo

```{r sessionInfo}
sessionInfo()
```

---
title: "Import and representation of MERFISH mouse hypothalamus data"
author: 
  - name: Ludwig Geistlinger    
    affiliation: Center for Computational Biomedicine, Harvard Medical School
  - name: Tyrone Lee  
    affiliation: Center for Computational Biomedicine, Harvard Medical School
  - name: Jeffrey Moffitt
    affiliation: Department of Microbiology, Harvard Medical School
  - name: Robert Gentleman
    affiliation: Center for Computational Biomedicine, Harvard Medical School
output:
  BiocStyle::html_document:
    self_contained: yes 
    toc: true
    toc_float: true
    toc_depth: 2
    code_folding: show
date: "`r doc_date()`"
vignette: >
  % \VignetteIndexEntry{Mouse hypothalamus}
  % \VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    crop = NULL ## Related to https://stat.ethz.ch/pipermail/bioc-devel/2020-April/016656.html
)
```

# Installation

To install the package, start R and enter: 

```{r, eval = FALSE}
if(!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("MerfishData")
``` 

# Setup

After the installation, we proceed by loading the package and additional packages
used in the vignette.

```{r, message = FALSE}
library(MerfishData)
library(ExperimentHub)
library(ggpubr)
```

# Data

[Moffitt et al., 2018](https://doi.org/10.1126/science.aau5324) 
developed an imaging-based cell type identification and mapping method and
combined it with single-cell RNA-sequencing to create a molecularly annotated
and spatially resolved cell atlas of the mouse hypothalamic preoptic region.

Def. hypothalamic preoptic region: is a part of the anterior hypothalamus that 
controls essential social behaviors and homeostatic functions.

Cell segmentation was carried out based on total polyadenylated mRNA and
DAPI nuclei costains. Combinatorial smFISH imaging was used for the 
identification and spatial expression profiling of 161 genes in 1,027,848 cells
from 36 mice (16 female, 20 male).

The data was obtained from the 
[datadryad data publication](https://doi.org/10.5061/dryad.8t8s248).

This vignette demonstrates how to obtain the MERFISH mouse hypothalamic preoptic
region dataset from [Moffitt et al., 2018](https://doi.org/10.1126/science.aau5324)
from Bioconductor's [ExperimentHub](https://bioconductor.org/packages/ExperimentHub).

```{r}
eh <- ExperimentHub()
AnnotationHub::query(eh, c("MerfishData", "hypothalamus"))
```

Note: complementary scRNA-seq of ~31,000 cells dissociated and captured from the
preoptic region of the hypothalamus from multiple male and female mice is available
on GEO ([GSE113576](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE113576)).

## Segmented data

It is also possible to obtain the data in a [SpatialExperiment](https://bioconductor.org/packages/SpatialExperiment), which integrates experimental data and cell metadata, and provides designated accessors for the spatial coordinates.

```{r, message = FALSE}
spe <- MouseHypothalamusMoffitt2018()
spe
```

Inspect the data components:

```{r}
assay(spe)[1:5,1:5]
assay(spe, "molecules")["Aldh1l1",1]
colData(spe)
head(spatialCoords(spe))
```

Def. Bregma: The bregma is the anatomical point on the skull at which the coronal
suture is intersected perpendicularly by the sagittal suture. Used here as a 
reference point for the twelve 1.8- by 1.8-mm imaged slices along the z-axis.

The anterior position of the preoptic region is at Bregma +0.26.

```{r}
table(spatialCoords(spe)[,"z"])
```

Cell type assignment:

```{r}
table(spe$cell_class)
```

# Visualization

Visualize cell centroids and annotated cell type labels as in Figure 3E of the 
[paper](https://doi.org/10.1126/science.aau5324)
for six different anterior-posterior positions from a single female mouse.

```{r}
relz <- c(0.26, 0.16, 0.06, -0.04, -0.14, -0.24)
cdat <- data.frame(colData(spe), spatialCoords(spe))
cdat <- subset(cdat, cell_class != "Ambiguous")
cdat$cell_class <- sub(" [1-4]$", "", cdat$cell_class)
cdat <- subset(cdat, z %in% relz)
cdat$z <- as.character(cdat$z)
zum <- paste(0:5 * 100, "um")
names(zum) <- as.character(relz)
cdat$z <- unname(zum[cdat$z]) 
```

```{r, fig.wide = TRUE, fig.width = 10, fig.height = 10}
pal <- get_palette("simpsons", 9)
names(pal) <- c("Endothelial", "Excitatory", "OD Immature", "Astrocyte", "Mural",
                "Microglia", "Ependymal", "Inhibitory", "OD Mature")
ggscatter(cdat, x = "x", y = "y", color = "cell_class", facet.by = "z",
          shape = 20, size = 1, palette = pal) +
          guides(color = guide_legend(override.aes = list(size = 3)))
```

# Interactive exploration

The MERFISH mouse hypothalamus dataset is part of the
[gallery of publicly available MERFISH datasets](https://moffittlab.connect.hms.harvard.edu/merfish/merfish_homepage.html).

This gallery consists of dedicated 
[iSEE](https://bioconductor.org/packages/iSEE) and 
[Vitessce](http://vitessce.io/) instances, published on 
[Posit Connect](https://posit.co/products/enterprise/connect/), 
that enable the interactive exploration of different segmentations,
the expression of marker genes, and overlay of
cell metadata on a spatial grid or a microscopy image.

# SessionInfo

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hypothalamus.R
\name{MouseHypothalamusMoffitt2018}
\alias{MouseHypothalamusMoffitt2018}
\title{MERFISH mouse hypothalamus dataset from Moffitt et al., 2018}
\source{
\url{https://doi.org/10.5061/dryad.8t8s248}
}
\usage{
MouseHypothalamusMoffitt2018(center.coords = TRUE)
}
\arguments{
\item{center.coords}{logical. Should spatial x- and y-coordinates be centered
for each z-layer (bregma slice)? This is useful for making coordinates
comparable between bregma slices for visualization and analysis.
Defaults to \code{TRUE}. Use \code{FALSE} to obtain the coordinates as
provided in the data release.}
}
\value{
An object of class \code{\linkS4class{SpatialExperiment}}.
}
\description{
Obtain the MERFISH mouse hypothalamic preoptic region dataset
from Moffitt et al., 2018
}
\details{
The hypothalamus controls essential social behaviors and homeostatic
functions. However, the cellular architecture of hypothalamic nuclei, including
the molecular identity, spatial organization, and function of distinct cell
types, is not well understood.

Moffitt et al., 2018, developed an imaging-based cell type identification and
mapping method and combined it with single-cell RNA-sequencing to create a
molecularly annotated and spatially resolved cell atlas of the mouse hypothalamic
preoptic region.

The MERFISH measurements were obtained via combinatorial smFISH imaging for
135 genes (main experiment named \code{"smFISH"}), followed by sequential rounds
of non-combinatorial seqFISH for 20 additional genes (stored as an \code{altExp}
named \code{"seqFISH"}). These genes were considered neuronal markers and important
for discriminating neuronal cell populations. For behavioral measurements,
cFos was added to the set of genes measured with sequential rounds of FISH.

The barcoding scheme contained 140 possible barcodes; 135 of them were used to
code the RNAs of the genes assayed via combinatorial smFISH; 5 of these barcodes
were left unassigned ("blank"), providing a direct measure of the false-positive
rate in MERFISH. Measurements for these 5 blank barcodes is stored in an
\code{altExp} named \code{"blank"}.
}
\examples{
spe <- MouseHypothalamusMoffitt2018()
}
\references{
Moffitt et al. (2018) Molecular, spatial, and functional
single-cell profiling of the hypothalamic preoptic region.
Science, 362(6416), eaau5324.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plotRasterImage}
\alias{plotRasterImage}
\title{Plot raster image}
\usage{
plotRasterImage(img)
}
\arguments{
\item{img}{a raster object representing a bitmap image.}
}
\value{
A ggplot object.
}
\description{
Small helper function to plot a raster image.
}
\examples{
 hgrid <- hcl(0, 80, seq(50, 80, 10))
 img <- as.raster(matrix(hgrid, nrow = 4, ncol = 5))
 plotRasterImage(img)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plotTabset}
\alias{plotTabset}
\title{Plot a tabset}
\usage{
plotTabset(spe.list, img)
}
\arguments{
\item{spe.list}{A named \code{list} of \code{\linkS4class{SpatialExperiment}}
objects.}

\item{img}{a raster object representing a bitmap image.}
}
\value{
None. Produces a tabset for rendering with \code{rmarkdown}.
}
\description{
Plot a tabset of colData annotations of one or more
SpatialExperiment objects over an image.
}
\examples{
 # create simulated data as described in the SpatialExperiment man page
 n <- 1000; ng <- 50; nc <- 20
 x <- runif(n)
 y <- runif(n)

 # assign each molecule to some gene-cell pair
 gs <- paste0("gene", seq(ng))
 cs <- paste0("cell", seq(nc))
 gene <- sample(gs, n, TRUE)
 cell <- sample(cs, n, TRUE)

 # generate molecule coordinates
 df <- data.frame(gene, cell, x, y)
 df$gene <- factor(df$gene, gs)
 df$cell <- factor(df$cell, cs)

 mol <- BumpyMatrix::splitAsBumpyMatrix(
         df[, c("x", "y")],
         row = df$gene, column = df$cell)

 # generate gene x cell molecule count matrix
 y <- with(df, table(gene, cell))
 y <- as.matrix(unclass(y))

 # construct SpatialExperiment
 spe <- SpatialExperiment(assays = list(counts = y, molecules = mol))

 # add simulated cell centroids
 s <- cbind(x = runif(20), y = runif(20))    
 spatialCoords(spe) <- s 

 # add simulated cell type and cell cycle annotation
 ct <- c("ct1", "ct2", "ct3")
 cc <- c("G1", "G2", "S", "M") 
 spe$type <- sample(ct, ncol(spe), replace = TRUE)
 spe$cycle <- sample(cc, ncol(spe), replace = TRUE)

 # create an example image
 hgrid <- hcl(0, 80, seq(50, 80, 10))
 img <- as.raster(matrix(hgrid, nrow = 4, ncol = 5))

 # plotTabset
 spe.list <- list(myseg = spe)
 plotTabset(spe.list, img)  
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ileum.R
\name{MouseIleumPetukhov2021}
\alias{MouseIleumPetukhov2021}
\title{MERFISH mouse ileum dataset from Petukhov et al., 2021}
\source{
\url{https://doi.org/10.5061/dryad.jm63xsjb2}
}
\usage{
MouseIleumPetukhov2021(
  segmentation = c("baysor", "cellpose"),
  use.images = TRUE,
  use.polygons = TRUE
)
}
\arguments{
\item{segmentation}{character. Should be either \code{"baysor"} or
\code{"cellpose"}. Defaults to \code{"baysor"}. See details.}

\item{use.images}{logical. Should DAPI and Membrane Na+/K+ - ATPase images
be loaded into memory and annotated to the \code{\link{imgData}} slot of
the returned \code{\linkS4class{SpatialExperiment}}? Defaults to \code{TRUE}.
See details.}

\item{use.polygons}{logical. Should polygon cell boundaries be annotated
to the \code{\link{metadata}} of the returned \code{\linkS4class{SpatialExperiment}}?
Defaults to \code{TRUE}. Only available for Baysor segmentation.}
}
\value{
An object of class \code{\linkS4class{SpatialExperiment}}.
}
\description{
Obtain the MERFISH mouse ileum dataset from Petukhov et al., 2021
}
\details{
Spatial transcriptomics protocols based on in situ sequencing or
multiplexed RNA fluorescent hybridization can reveal detailed tissue organization.
Distinguishing the boundaries of individual cells in such data is challenging.
Current segmentation methods typically approximate cells positions using nuclei
stains.

Petukhov et al., 2021, describe Baysor, a segmentation method,
which optimizes 2D or 3D cell boundaries considering joint likelihood of
transcriptional composition and cell morphology.
Baysor can also perform segmentation based on the detected transcripts alone.

Petukhov et al., 2021, compare the results of Baysor segmentation (mRNA-only)
to the results of a deep learning-based segmentation method called Cellpose from
Stringer et al., 2021. Cellpose applies a machine learning framework for the
segmentation of cell bodies, membranes and nuclei from microscopy images.

The function allows to obtain segmented MERFISH mouse ileum data for both
segmentation methods.

A note on storing images within a \code{\linkS4class{SpatialExperiment}}:
The default \code{use.images = TRUE} reduces the 9-frame z-stack images
for DAPI stain and Membrane Na+/K+ - ATPase fluorecense to single-frame
images (taking the first frame). For working with the 9-frame z-stack
images it is recommended to load the images individually from ExperimentHub.
}
\examples{
spe <- MouseIleumPetukhov2021()
}
\references{
Petukhov et al. (2021) Cell segmentation in imaging-based
spatial transcriptomics. Nat Biotechnol, 40(3), 345-54.

Stringer et al. (2021) Cellpose: a generalist algorithm for cellular
segmentation.  Nat Methods, 18(1), 100-6.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ibd.R
\name{MouseColonIbdCadinu2024}
\alias{MouseColonIbdCadinu2024}
\title{MERFISH mouse colon IBD dataset from Cadinu et al., 2024}
\source{
\url{https://doi.org/10.5061/dryad.rjdfn2zh3}
}
\usage{
MouseColonIbdCadinu2024()
}
\value{
An object of class \code{\linkS4class{SpatialExperiment}}.
}
\description{
Obtain the MERFISH mouse colon IBD dataset from Cadinu et al.,
2024
}
\details{
Gut inflammation involves contributions from immune and non-immune cells,
whose interactions are shaped by the spatial organization of the healthy gut and its
remodeling during inflammation.
The crosstalk between fibroblasts and immune cells is an important axis in this process,
but our understanding has been challenged by incomplete cell-type definition and biogeography.

To address this challenge, Cadinu et al., 2024 used multiplexed error-robust
fluorescence in situ hybridization
(MERFISH) to profile the expression of 943 genes in 1.35 million cells imaged
across the onset and recovery from a mouse colitis model.
They identified diverse cell populations, charted their
spatial organization, and revealed their polarization or recruitment in
inflammation.

The barcoding scheme contained 990 possible barcodes; 943 of them were used to
code the RNAs of the genes assayed via combinatorial smFISH across different
stages of colitis in a mouse model; 47 of these barcodes
were left unassigned ("blank"), providing a direct measure of the false-positive
rate in MERFISH. Measurements for these 47 blank barcodes is stored in an
\code{altExp} named \code{"blank"}.

The dataset includes cell type labels with three levels of granularity.
Data were collected at multiple time points: prior to the onset of colitis
(\code{sample_type="Healthy"}) and at intervals of 3 days, 9 days,
and 21 days post-onset.
}
\examples{
spe <- MouseColonIbdCadinu2024()
}
\references{
Cadinu et al. (2024) Charting the cellular biogeography in
colitis reveals fibroblast trajectories and coordinated spatial remodeling.
Cell, 187(8).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{plotXY}
\alias{plotXY}
\title{Plot spatial image with data overlay}
\usage{
plotXY(df, col, img = NULL)
}
\arguments{
\item{df}{A \code{data.frame} storing the data to plot.}

\item{col}{character. A column of \code{df} to use for overlay onto the image.}

\item{img}{a raster object representing a bitmap image.}
}
\value{
A ggplot.
}
\description{
A helper function to overlay data onto a spatial image.
}
\examples{
 gene <- rep(c("Cd44", "Cd8b1", "Cd79b"), each = 2)
 x <- c(1693, 1701, 1820, 3188, 1631, 1881)
 y <- c(1831, 1666, 1855, 6612, 1533, 942)
 df <- data.frame(gene = gene, x = x, y = y)
 plotXY(df, "gene")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MerfishData-package.R
\docType{package}
\name{MerfishData-package}
\alias{MerfishData-package}
\alias{MerfishData}
\title{Collection of public MERFISH datasets}
\description{
MerfishData is an ExperimentHub package that serves publicly available
datasets obtained with Multiplexed Error-Robust Fluorescence in situ Hybridization
(MERFISH). MERFISH is a massively multiplexed single-molecule imaging technology
capable of simultaneously measuring the copy number and spatial distribution
of hundreds to tens of thousands of RNA species in individual cells. The scope
of the package is to provide MERFISH data for benchmarking and analysis.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/ccb-hms/MerfishData}
  \item Report bugs at \url{https://github.com/ccb-hms/MerfishData/issues}
}

}
\author{
Ludwig Geistlinger \href{mailto:ludwig_geistlinger@hms.harvard.edu}{ludwig_geistlinger@hms.harvard.edu}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{addHolesToPolygons}
\alias{addHolesToPolygons}
\title{Add holes to polygons}
\usage{
addHolesToPolygons(poly)
}
\arguments{
\item{poly}{A \code{data.frame} storing cell polygon coordinates.
Expected columns include \itemize{
\item \code{"cell"} storing the cell ID,
\item \code{"x"} storing x-coordinates of the polygon corners,
\item \code{"y"} storing the y-coordinates of the polygon corners.}}
}
\value{
A \code{data.frame}
}
\description{
Add holes to a \code{data.frame} of cell polygon coordinates
}
\examples{
     x <- c(2053, 2053, 2053, 2056, 2059, 2059)
     y <- c(51, 54, 57, 57, 57, 54)
     poly <- data.frame(cell = 1, x = x, y = y)
     poly <- addHolesToPolygons(poly)
}
